Index: /trunk/src/sys/arch/mips/mips/mipsX_subr.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/mipsX_subr.S	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/mipsX_subr.S	(revision 152)
@@ -1665,85 +1838,4 @@
  *
  * Side effects:
- *	None.
- *
- *----------------------------------------------------------------------------
- */
-LEAF_NOPROFILE(MIPSX(kernel_tlb_miss))
-	.set	noat
-	_MFC0	k0, MIPS_COP_0_BAD_VADDR	# get the fault address
-#if VM_MIN_KERNEL_ADDRESS == MIPS_KSEG2_START
-	li	k1, VM_MIN_KERNEL_ADDRESS	# compute index
-#else
-	li	k1, VM_MIN_KERNEL_ADDRESS>>32	# compute index
-	dsll32	k1, k1, 0
-#endif
-	PTR_SUBU k0, k0, k1
-	INT_L	k1, _C_LABEL(Sysmapsize)	# index within range?
-	PTR_SRL	k0, k0, PGSHIFT
-	sltu	k1, k0, k1
-#ifdef newsmips
-	/* news5000 has ROM work area at 0xfff00000. */
-	bnez	k1, 1f
-	 nop
-	j	checkromwork
-	 nop					# - delay slot -
-1:
-#else
-	/*
-	 * If we are beyond the bounds of Sysmap, let trap panic for us.
-	 */
-	beqz	k1, _C_LABEL(MIPSX(kern_gen_exception)) # No. Failing beyond. . .
-	 move	k1, MIPS_CURLWP			# - delay slot -
-#endif
-	PTR_L	k1, _C_LABEL(Sysmap)
-	PTR_SRL	k0, k0, 1
-	PTR_SLL	k0, k0, 3			# compute offset from index
-	PTR_ADDU k1, k1, k0
-	INT_L	k0, 0(k1)			# get PTE entry
-	INT_L	k1, 4(k1)			# get odd PTE entry
-	_SLL	k0, k0, WIRED_SHIFT		# get rid of "wired" bit
-	_SRL	k0, k0, WIRED_SHIFT
-	_MTC0	k0, MIPS_COP_0_TLB_LO0		# load PTE entry
-	COP0_SYNC
-	_SLL	k1, k1, WIRED_SHIFT
-	_SRL	k1, k1, WIRED_SHIFT
-	_MTC0	k1, MIPS_COP_0_TLB_LO1		# load PTE entry
-	COP0_SYNC
-	nop
-	nop					# required for QED5230
-	tlbwr					# write TLB
-	COP0_SYNC
-	nop
-	nop
-	nop
-	nop
-	nop
-	eret
-	.set	at
-END(MIPSX(kernel_tlb_miss))
-
-	MSG("TLB out of universe: ksp %p epc %p vaddr %p")
-
-/*
- * Mark where code entered from exception hander jumptable
- * ends, for stack traceback code.
- */
-
-	.globl	_C_LABEL(MIPSX(exceptionentry_end))
-_C_LABEL(MIPSX(exceptionentry_end)):
-
-/*--------------------------------------------------------------------------
- *
- * mipsN_tlb_set_asid --
- *
- *	Write the given pid into the TLB pid reg.
- *
- *	mips3_tlb_set_asid(uint32_t pid)
- *		int pid;
- *
- * Results:
- *	None.
- *
- * Side effects:
  *	PID set in the entry hi register.
  *
@@ -1752,81 +1844,14 @@
 LEAF(MIPSX(tlb_set_asid))
 	_MTC0	a0, MIPS_COP_0_TLB_HI		# Write the hi reg value
-	COP0_SYNC
-	/* XXX simonb: lose these nops for mips32/64? */
-	nop					# required for QED5230
-	nop					# required for QED5230
-	j	ra
-	nop
+	JR_HB_RA
 END(MIPSX(tlb_set_asid))
 
-#if defined(ENABLE_MIPS3_WIRED_MAP)
 /*--------------------------------------------------------------------------
  *
- * mipsN_TLBWriteIndexedVPS --
- *
- *      Write the given entry into the TLB at the given index.
- *      Pass full R4000 style TLB info including variable page size mask.
- *
- *      mipsN_tlb_write_indexed(size_t tlb_index, const struct tlbmask *tlb)
- *
- * Results:
- *      None.
- *
- * Side effects:
- *      TLB entry set.
- *
- *--------------------------------------------------------------------------
- */
-LEAF(MIPSX(tlb_write_indexed_VPS))
-	mfc0	v1, MIPS_COP_0_STATUS		# Save the status register.
-	RESET_EXCEPTION_LEVEL_DISABLE_INTERRUPTS(v0)
-	COP0_SYNC
-	nop
-	INT_L	a2, TLBMASK_LO0(a1)		# fetch tlb->tlb_lo0
-	INT_L	a3, TLBMASK_LO1(a1)		# fetch tlb->tlb_lo1
-	mfc0	v0, MIPS_COP_0_TLB_PG_MASK	# Save current page mask.
-	_MFC0	t0, MIPS_COP_0_TLB_HI		# Save the current PID.
-
-	_MTC0	a2, MIPS_COP_0_TLB_LO0		# Set up entry low0.
-	COP0_SYNC
-	_MTC0	a3, MIPS_COP_0_TLB_LO1		# Set up entry low1.
-	COP0_SYNC
-	nop
-	INT_L	a2, TLBMASK_MASK(a1)		# fetch tlb->tlb_mask
-	PTR_L	a3, TLBMASK_HI(a1)		# fetch tlb->tlb_hi
-	nop
-	mtc0	a0, MIPS_COP_0_TLB_INDEX	# Set the index.
-	COP0_SYNC
-	mtc0	a2, MIPS_COP_0_TLB_PG_MASK	# Set up entry pagemask.
-	COP0_SYNC
-	_MTC0	a3, MIPS_COP_0_TLB_HI		# Set up entry high.
-	COP0_SYNC
-	nop
-	nop
-	tlbwi					# Write the TLB
-	COP0_SYNC
-	nop
-	nop
-	nop					# Delay for effect
-	nop
-
-	_MTC0	t0, MIPS_COP_0_TLB_HI		# Restore the PID.
-	COP0_SYNC
-	mtc0	v0, MIPS_COP_0_TLB_PG_MASK	# Restore page mask.
-	COP0_SYNC
-	nop
-	nop
-	j       ra
-	mtc0	v1, MIPS_COP_0_STATUS		# Restore the status register
-END(MIPSX(tlb_write_indexed_VPS))
-#endif /* ENABLE_MIPS3_WIRED_MAP */
-	
-/*--------------------------------------------------------------------------
- *
- * mipsN_tlb_update --
+ * mipsN_tlb_update_addr --
  *
  *	Update the TLB if highreg is found; otherwise do nothing.
  *
- *	long mipsN_tlb_update(vaddr_t va, register_t lowreg)
+ *	int mipsN_tlb_update_addr(vaddr_t va, register_t lowreg)
  *
  * Results:
@@ -1838,5 +1863,5 @@
  *--------------------------------------------------------------------------
  */
-LEAF(MIPSX(tlb_update))
+LEAF(MIPSX(tlb_update_addr))
 	mfc0	v1, MIPS_COP_0_STATUS	# Save the status register.
 	mtc0	zero, MIPS_COP_0_STATUS	# Disable interrupts
@@ -1849,67 +1874,54 @@
 	COP0_SYNC
 	and	a2, a1, MIPS3_PG_G		# Copy global bit
-	nop
-	nop
 	tlbp					# Probe for the entry.
 	COP0_SYNC
+#if (MIPS32R2 + MIPS64R2 + MIPS64R2_RMIXL) > 0
+	_EXT	a1, a1, 0, WIRED_POS
+#else
 	_SLL	a1, a1, WIRED_SHIFT		# Clear top 34 bits of EntryLo
 	_SRL	a1, a1, WIRED_SHIFT
+#endif
+	mfc0	v0, MIPS_COP_0_TLB_INDEX	# See what we got
 	bnez	t1, 1f				# Decide even odd
-	mfc0	v0, MIPS_COP_0_TLB_INDEX	# See what we got
+	 nop
 # EVEN
-	nop
 	bltz	v0, 1f				# index < 0 => !found
-	nop
+	 nop
+#ifdef MIPS3
 	nop					# required for QED5230
-
+#endif
 	tlbr					# update, read entry first
 	COP0_SYNC
-	nop
-	nop
-	nop
 	_MTC0	a1, MIPS_COP_0_TLB_LO0		# init low reg0.
 	COP0_SYNC
-	nop
-	nop					# required for QED5230
 	tlbwi					# update slot found
 	COP0_SYNC
-	nop					# required for QED5230
-	nop					# required for QED5230
 	b	4f
-	nop
+	 nop
 1:
 # ODD
-	nop
 	bltz	v0, 4f				# index < 0 => !found
-	nop
+	 nop
+#ifdef MIPS3
 	nop					# required for QED5230
-
+#endif
 	tlbr					# read the entry first
 	COP0_SYNC
-	nop
-	nop
-	nop
 	_MTC0	a1, MIPS_COP_0_TLB_LO1		# init low reg1.
 	COP0_SYNC
-	nop
-	nop					# required for QED5230
 	tlbwi					# update slot found
 	COP0_SYNC
-	nop					# required for QED5230
-	nop					# required for QED5230
-	nop
 4:
+#ifdef MIPS3
 	nop					# Make sure pipeline
 	nop					# advances before we
 	nop					# use the TLB.
 	nop
+#endif
 	_MTC0	t0, MIPS_COP_0_TLB_HI		# restore PID
 	COP0_SYNC
-	nop					# required for QED5230
-	nop					# required for QED5230
-	j	ra
 	mtc0	v1, MIPS_COP_0_STATUS		# Restore the status register
-	COP0_SYNC				# XXXX - not executed!!
-END(MIPSX(tlb_update))
+	JR_HB_RA
+END(MIPSX(tlb_update_addr))
 
 /*--------------------------------------------------------------------------
@@ -1933,18 +1945,14 @@
 	mtc0	zero, MIPS_COP_0_STATUS		# Disable interrupts
 	COP0_SYNC
+	mfc0	ta2, MIPS_COP_0_TLB_PG_MASK	# save current pgMask
+#ifdef MIPS3
 	nop
-	mfc0	ta2, MIPS_COP_0_TLB_PG_MASK	# save current pgMask
-	nop
+#endif
 	_MFC0	t0, MIPS_COP_0_TLB_HI		# Get current PID
 
 	mtc0	a0, MIPS_COP_0_TLB_INDEX	# Set the index register
 	COP0_SYNC
-	nop
-	nop					# required for QED5230
 	tlbr					# Read from the TLB
 	COP0_SYNC
-	nop
-	nop
-	nop
 	mfc0	t2, MIPS_COP_0_TLB_PG_MASK	# fetch the pgMask
 	_MFC0	t3, MIPS_COP_0_TLB_HI		# fetch the hi entry
@@ -1952,112 +1960,363 @@
 	_MFC0	ta1, MIPS_COP_0_TLB_LO1		# See what we got
 	_MTC0	t0, MIPS_COP_0_TLB_HI		# restore PID
-	COP0_SYNC
 	mtc0	ta2, MIPS_COP_0_TLB_PG_MASK	# restore pgMask
 	COP0_SYNC
-	nop
-	nop
-	nop					# wait for PID active
 	mtc0	v1, MIPS_COP_0_STATUS		# Restore the status register
 	COP0_SYNC
-	nop
 	PTR_S	t3, TLBMASK_HI(a1)
 	INT_S	ta0, TLBMASK_LO0(a1)
 	INT_S	ta1, TLBMASK_LO1(a1)
 	j	ra
-	INT_S	t2, TLBMASK_MASK(a1)
+	 INT_S	t2, TLBMASK_MASK(a1)
 END(MIPSX(tlb_read_indexed))
 
-#if defined(MIPS3) && !defined(MIPS3_5900)
-/*----------------------------------------------------------------------------
- *
- * mipsN_VCED --
- *
- *	Handle virtual coherency exceptions.
- *	Called directly from the mips3 exception-table code.
- *	only k0, k1 are available on entry
- *
- * Results:
- *	None.
- *
- * Side effects:
- *	Remaps the conflicting address as uncached and returns
- *	from the exception.
- *
- *	NB: cannot be profiled, all registers are user registers on entry.
- *
- *----------------------------------------------------------------------------
- */
-LEAF_NOPROFILE(MIPSX(VCED))
+
+/*--------------------------------------------------------------------------
+ * Invalidate a TLB entry which has the given vaddr and ASID if found.
+ * void mipsN_tlb_invalidate_addr(vaddr_t va)
+ *
+ * Invalidate a TLB entry which has the given vaddr and ASID if found.
+ *--------------------------------------------------------------------------
+ */
+LEAF_NOPROFILE(MIPSX(tlb_invalidate_addr))
+	mfc0	v1, MIPS_COP_0_STATUS		# save status register
+	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
+	COP0_SYNC
+
+	li	v0, (MIPS3_PG_HVPN | MIPS3_PG_ASID)
+	_MFC0	t0, MIPS_COP_0_TLB_HI		# save current ASID
+	mfc0	t3, MIPS_COP_0_TLB_PG_MASK	# save current pgMask
+	and	a0, v0				# make sure valid entryHi
+	_MTC0	a0, MIPS_COP_0_TLB_HI		# look for the vaddr & ASID
+	COP0_SYNC
+	tlbp					# probe the entry in question
+	COP0_SYNC
+	mfc0	v0, MIPS_COP_0_TLB_INDEX	# see what we got
+	bltz	v0, 1f				# index < 0 then skip
+	 li	t1, MIPS_KSEG0_START		# invalid address
+	PTR_SLL	v0, PGSHIFT + 1			# PAGE_SHIFT + 1
+	PTR_ADDU t1, v0
+	_MTC0	t1, MIPS_COP_0_TLB_HI		# make entryHi invalid
+	_MTC0	zero, MIPS_COP_0_TLB_LO0	# zero out entryLo0
+	_MTC0	zero, MIPS_COP_0_TLB_LO1	# zero out entryLo1
+#if 0
+	mtc0	zero, MIPS_COP_0_TLB_PG_MASK	# zero out pageMask
+#endif
+	COP0_SYNC
+
+	tlbwi
+	COP0_SYNC
+1:
+	_MTC0	t0, MIPS_COP_0_TLB_HI		# restore current ASID
+	mtc0	t3, MIPS_COP_0_TLB_PG_MASK	# restore pgMask
+	COP0_SYNC
+	mtc0	v1, MIPS_COP_0_STATUS		# restore status register
+	JR_HB_RA
+END(MIPSX(tlb_invalidate_addr))
+
+/*
+ * void mipsN_tlb_invalidate_asids(uint32_t base, uint32_t limit);
+ *
+ * Invalidate TLB entries belong to per process user spaces with
+ * base <= ASIDs < limit while leaving entries for kernel space
+ * marked global intact.
+ */
+LEAF_NOPROFILE(MIPSX(tlb_invalidate_asids))
+	mfc0	v1, MIPS_COP_0_STATUS		# save status register
+	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
+	COP0_SYNC
+
+	_MFC0	t0, MIPS_COP_0_TLB_HI		# Save the current PID.
+	mfc0	t1, MIPS_COP_0_TLB_WIRED
+	li	v0, MIPS_KSEG0_START		# invalid address
+	INT_L	t2, _C_LABEL(mips_options) + MO_NUM_TLB_ENTRIES
+	mfc0	t3, MIPS_COP_0_TLB_PG_MASK	# save current pgMask
+
+	# do {} while (t1 < t2)
+1:
+	mtc0	t1, MIPS_COP_0_TLB_INDEX	# set index
+	COP0_SYNC
+	sll	ta0, t1, PGSHIFT + 1		# PAGE_SHIFT + 1
+	tlbr					# obtain an entry
+	COP0_SYNC
+	_MFC0	a0, MIPS_COP_0_TLB_LO1
+	and	a0, MIPS3_PG_G			# check to see it has G bit
+	bnez	a0, 2f				# yep, skip this one.
+	 nop
+	_MFC0	a0, MIPS_COP_0_TLB_HI		# get VA and ASID
+	and	a0, MIPS3_PG_ASID		# focus on ASID
+	sltu	a3, a0, a1			# asid < base?
+	bnez	a3, 2f				# yes, skip this entry.
+	 nop
+	sltu	a3, a0, a2			# asid < limit
+	beqz	a3, 2f				# nope, skip this entry.
+	 nop
+	PTR_ADDU ta0, v0
+
+	_MTC0	ta0, MIPS_COP_0_TLB_HI		# make entryHi invalid
+	_MTC0	zero, MIPS_COP_0_TLB_LO0	# zero out entryLo0
+	_MTC0	zero, MIPS_COP_0_TLB_LO1	# zero out entryLo1
+	mtc0	zero, MIPS_COP_0_TLB_PG_MASK	# zero out mask entry
+	COP0_SYNC
+	tlbwi					# invalidate the TLB entry
+	COP0_SYNC
+2:
+	addu	t1, 1
+	bne	t1, t2, 1b
+	 nop
+
+	_MFC0	t0, MIPS_COP_0_TLB_HI		# restore PID.
+	mtc0	t3, MIPS_COP_0_TLB_PG_MASK	# restore pgMask
+	COP0_SYNC
+	mtc0	v1, MIPS_COP_0_STATUS		# restore status register
+	JR_HB_RA				# new ASID will be set soon
+END(MIPSX(tlb_invalidate_asids))
+
+/*
+ * void mipsN_tlb_invalidate_globals(void);
+ *
+ * Invalidate the non-wired TLB entries belonging to kernel space while
+ * leaving entries for user space (not marked global) intact.
+ */
+LEAF_NOPROFILE(MIPSX(tlb_invalidate_globals))
+	mfc0	v1, MIPS_COP_0_STATUS		# save status register
+	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
+	COP0_SYNC
+
+	_MFC0	t0, MIPS_COP_0_TLB_HI		# save current ASID
+	mfc0	t1, MIPS_COP_0_TLB_WIRED
+	li	v0, MIPS_KSEG0_START		# invalid address
+	INT_L	t2, _C_LABEL(mips_options) + MO_NUM_TLB_ENTRIES
+	mfc0	t3, MIPS_COP_0_TLB_PG_MASK	# save current pgMask
+
+	# do {} while (t1 < t2)
+1:
+	mtc0	t1, MIPS_COP_0_TLB_INDEX	# set index
+	COP0_SYNC
+	sll	ta0, t1, PGSHIFT + 1		# PAGE_SHIFT + 1
+	tlbr					# obtain an entry
+	COP0_SYNC
+	_MFC0	a0, MIPS_COP_0_TLB_LO1
+	and	a0, MIPS3_PG_G			# check to see it has G bit
+	beqz	a0, 2f				# no, skip this entry
+	 nop
+	PTR_ADDU ta0, v0
+
+	_MTC0	ta0, MIPS_COP_0_TLB_HI		# make entryHi invalid
+	_MTC0	zero, MIPS_COP_0_TLB_LO0	# zero out entryLo0
+	_MTC0	zero, MIPS_COP_0_TLB_LO1	# zero out entryLo1
+	mtc0	zero, MIPS_COP_0_TLB_PG_MASK	# zero out mask entry
+	COP0_SYNC
+	tlbwi					# invalidate the TLB entry
+	COP0_SYNC
+2:
+	addu	t1, 1
+	bne	t1, t2, 1b
+	 nop
+
+	_MTC0	t0, MIPS_COP_0_TLB_HI		# restore current ASID
+	mtc0	t3, MIPS_COP_0_TLB_PG_MASK	# restore pgMask
+	COP0_SYNC
+	mtc0	v1, MIPS_COP_0_STATUS		# restore status register
+	JR_HB_RA
+END(MIPSX(tlb_invalidate_globals))
+
+/*
+ * void mipsN_tlb_invalidate_all(void);
+ *
+ * Invalidate all of non-wired TLB entries.
+ */
+LEAF_NOPROFILE(MIPSX(tlb_invalidate_all))
+	mfc0	v1, MIPS_COP_0_STATUS		# save status register
+	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
+	COP0_SYNC
+
+	INT_L	a0, _C_LABEL(mips_options) + MO_NUM_TLB_ENTRIES
+
+	li	v0, MIPS_KSEG0_START		# invalid address
+	_MFC0	t0, MIPS_COP_0_TLB_HI		# save current ASID
+	mfc0	t1, MIPS_COP_0_TLB_WIRED
+	mfc0	t2, MIPS_COP_0_TLB_PG_MASK	# save current pgMask
+
+	_MTC0	zero, MIPS_COP_0_TLB_LO0	# zero out entryLo0
+	_MTC0	zero, MIPS_COP_0_TLB_LO1	# zero out entryLo1
+	mtc0	zero, MIPS_COP_0_TLB_PG_MASK	# zero out pageMask
+
+	# do {} while (t1 < a0)
+1:
+	mtc0	t1, MIPS_COP_0_TLB_INDEX	# set TLBindex
+	COP0_SYNC
+	sll	ta0, t1, PGSHIFT + 1		# PAGE_SHIFT + 1
+	PTR_ADDU ta0, v0
+	_MTC0	ta0, MIPS_COP_0_TLB_HI		# make entryHi invalid
+	COP0_SYNC
+	tlbwi					# clear the entry
+	COP0_SYNC
+	addu	t1, 1				# increment index
+	bne	t1, a0, 1b
+	 nop
+
+	_MTC0	t0, MIPS_COP_0_TLB_HI		# restore ASID
+	mtc0	t2, MIPS_COP_0_TLB_PG_MASK	# restore pgMask
+	COP0_SYNC
+	mtc0	v1, MIPS_COP_0_STATUS		# restore status register
+	JR_HB_RA
+END(MIPSX(tlb_invalidate_all))
+
+/*
+ * u_int mipsN_tlb_record_asids(u_long *bitmap, uint32_t asid_mask);
+ *
+ * Record all the ASIDs in use in the TLB and return the number of different
+ * ASIDs present.
+ */
+LEAF_NOPROFILE(MIPSX(tlb_record_asids))
+
+	_MFC0	a3, MIPS_COP_0_TLB_HI		# Save the current PID.
+	mfc0	ta0, MIPS_COP_0_TLB_WIRED
+	INT_L	ta1, _C_LABEL(mips_options) + MO_NUM_TLB_ENTRIES
+	move	ta2, zero
+	li	ta3, 1
+	move	v0, zero
+
+	mfc0	v1, MIPS_COP_0_STATUS		# save status register
+#ifdef _LP64
+	and	t0, v1, MIPS_SR_INT_IE
+	xor	t0, v1
+	mtc0	t0, MIPS_COP_0_STATUS		# disable interrupts
+#else
+	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
+#endif
+	COP0_SYNC
+
+	# do {} while (ta0 < ta1)
+1:
+	mtc0	ta0, MIPS_COP_0_TLB_INDEX	# set index
+	COP0_SYNC
+	tlbr					# obtain an entry
+	COP0_SYNC
+	_MFC0	t0, MIPS_COP_0_TLB_LO1
+	and	t0, MIPS3_PG_G			# check to see it has G bit
+	bnez	t0, 4f				# yep, skip this one.
+	 nop
+	_MFC0	t0, MIPS_COP_0_TLB_HI		# get VA and ASID
+	and	t0, a1				# focus on ASID
+
+	srl	a2, t0, 3 + LONG_SCALESHIFT	# drop low 5 or 6 bits
+	sll	a2, LONG_SCALESHIFT		# make an index for the bitmap
+	_SLLV	t0, ta3, t0			# t0 is mask (ta3 == 1)
+
+	PTR_ADDU a2, a0				# index into the bitmap 
+	beq	a2, ta2, 3f			# is the desired cell loaded?
+	 nop					#    yes, don't reload it
+	beqz	ta2, 2f				# have we ever loaded it?
+	 nop					#   nope, so don't save it.
+
+	LONG_S	t2, 0(ta2)			# save the updated value.
+2:
+	move	ta2, a2				# remember the new cell's addr
+	LONG_L	t2, 0(ta2)			# and load it
+3:
+	and	t1, t2, t0			# t1 = t2 & t0
+	sltu	t1, t1, ta3			# t1 = t1 < 1 (aka t1 == 0)
+	addu	v0, t1				# v0 += t1
+	or	t2, t0				# or in the new ASID bits
+4:
+	addu	ta0, 1				# increment TLB entry #
+	bne	ta0, ta1, 1b			# keep lookup if not limit
+	 nop
+
+	beqz	ta2, 5f				# do we have a cell to write?
+	 nop					#   nope.  nothing
+
+	LONG_S	t2, 0(ta2)			# save the updated value.
+5:
+	_MTC0	a3, MIPS_COP_0_TLB_HI		# restore ASID
+	COP0_SYNC
+
+	mtc0	v1, MIPS_COP_0_STATUS		# restore status register
+	JR_HB_RA
+END(MIPSX(tlb_record_asids))
+
+/*
+ * mipsN_tlb_enter(size_t tlb_index, vaddr_t va, uint32_t pte);
+ */
+LEAF(MIPSX(tlb_enter))
 	.set	noat
-	_MFC0	k0, MIPS_COP_0_BAD_VADDR	# fault addr.
-	li	k1, -16
-	and	k0, k1
-	cache	(CACHE_R4K_SD | CACHEOP_R4K_HIT_WB_INV), 0(k0)
-	cache	(CACHE_R4K_D | CACHEOP_R4K_HIT_INV), 0(k0)
-#ifdef DEBUG
-	_MFC0	k0, MIPS_COP_0_BAD_VADDR
-	PTR_LA	k1, VCED_vaddr
-	PTR_S	k0, 0(k1)
-	_MFC0	k0, MIPS_COP_0_EXC_PC
-	PTR_LA	k1, VCED_epc
-	PTR_S	k0, 0(k1)
-	PTR_LA	k1, VCED_count		# count number of exceptions
-	PTR_SRL	k0, k0, 26		# position upper 4 bits of VA
-	and	k0, k0, 0x3c		# mask it off
-	PTR_ADDU k1, k0			# get address of count table
-	LONG_L	k0, 0(k1)
-	LONG_ADDU k0, 1
-	LONG_S	k0, 0(k1)
-#endif
-	eret
+	_MFC0	ta0, MIPS_COP_0_TLB_HI		# save EntryHi
+
+	and	a3, a1, MIPS3_PG_ODDPG		# select odd page bit
+	xor	a3, a1				# clear it.
+	_MTC0	a3, MIPS_COP_0_TLB_HI		# set the VA for tlbp
+	COP0_SYNC
+
+	and	t2, a2, MIPS3_PG_G		# make prototype tlb_lo0
+	and	t3, a2, MIPS3_PG_G		# make prototype tlb_lo1
+
+	tlbp					# is va in TLB?
+	COP0_SYNC
+
+	mfc0	v0, MIPS_COP_0_TLB_INDEX	# was it in the TLB?
+	bltz	v0, 1f				# nope
+	 nop
+
+	/*
+	 * Get the existing tlb_lo's because we need to replace one of them.
+	 */
+	mfc0	t2, MIPS_COP_0_TLB_LO0		# save for update
+	mfc0	t3, MIPS_COP_0_TLB_LO1		# save for update
+
+	/*
+	 * If it's already where we want, no reason to invalidate it.
+	 */
+	beq	v0, a0, 2f			# already where we want it?
+	 nop					
+
+	/*
+	 * Make an
+	 */
+	sll	t1, 1 + PGSHIFT			# make a fake addr for the entry
+	lui	v1, %hi(MIPS_KSEG0_START)
+	or	t1, v1
+	_MTC0	t1, MIPS_COP_0_TLB_HI
+	COP0_SYNC
+
+	and	t0, a2, MIPS3_PG_G		# make prototype tlb_lo
+	mtc0	t0, MIPS_COP_0_TLB_LO0		# use an invalid tlb_lo0
+	mtc0	t0, MIPS_COP_0_TLB_LO1		# use an invalid tlb_lo1
+	COP0_SYNC
+
+	tlbwi					# now write the invalid TLB
+	COP0_SYNC
+
+	_MTC0	a3, MIPS_COP_0_TLB_HI		# restore the addr for new TLB
+	COP0_SYNC
+1:
+	mtc0	a0, MIPS_COP_0_TLB_INDEX	# set the index
+	COP0_SYNC
+
+2:
+	and	v1, a1, MIPS3_PG_ODDPG		# odd or even page
+	sll	v1, 31 - PGSHIFT		# move to MSB
+	sra	v1, 31				# v1 a mask (0/~0 = even/odd)
+	not	v0, v1				# v0 a mask (~0/0 = even/odd)
+
+	and	ta2, t2, v1
+	and	ta3, a2, v0
+	or	t2, ta2, ta3			# t2 = (v1 & t2) | (~v1 & a2)
+	and	ta2, t3, v0
+	and	ta3, a2, v1
+	or	t3, ta2, ta3			# t3 = (~v1 & t3) | (v1 & a2)
+
+	mtc0	t2, MIPS_COP_0_TLB_LO0		# set tlb_lo0 (even)
+	mtc0	t3, MIPS_COP_0_TLB_LO1		# set tlb_lo1 (odd)
+	COP0_SYNC
+
+	tlbwi					# enter it into the TLB
+	COP0_SYNC
+
+	_MTC0	ta1, MIPS_COP_0_TLB_HI		# restore EntryHi
+	JR_HB_RA
 	.set	at
-
-#ifdef DEBUG
-	.data
-	.globl	_C_LABEL(VCED_count)
-_C_LABEL(VCED_count):
-	LONG_WORD	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
-	.globl	_C_LABEL(VCED_epc)
-_C_LABEL(VCED_epc):
-	PTR_WORD	0
-	.globl	_C_LABEL(VCED_vaddr)
-_C_LABEL(VCED_vaddr):
-	PTR_WORD	0
-	.text
-#endif
-END(MIPSX(VCED))
-
-LEAF_NOPROFILE(MIPSX(VCEI))
-	.set	noat
-	_MFC0	k0, MIPS_COP_0_BAD_VADDR	# fault addr.
-	cache	(CACHE_R4K_SD | CACHEOP_R4K_HIT_WB_INV), 0(k0)
-	cache	(CACHE_R4K_I | CACHEOP_R4K_HIT_INV), 0(k0)
-#ifdef DEBUG
-	_MFC0	k0, MIPS_COP_0_BAD_VADDR
-	PTR_LA	k1, VCEI_vaddr
-	PTR_S	k0, 0(k1)
-	PTR_LA	k1, VCEI_count		# count number of exceptions
-	PTR_SRL	k0, k0, 26		# position upper 4 bits of VA
-	and	k0, k0, 0x3c		# mask it off
-	PTR_ADDU k1, k0			# get address of count table
-	LONG_L	k0, 0(k1)
-	PTR_ADDU k0, 1
-	LONG_S	k0, 0(k1)
-#endif
-	eret
-	.set	at
-
-#ifdef DEBUG
-	.data
-	.globl	_C_LABEL(VCEI_count)
-_C_LABEL(VCEI_count):
-	LONG_WORD	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
-	.globl	_C_LABEL(VCEI_vaddr)
-_C_LABEL(VCEI_vaddr):
-	PTR_WORD	0
-	.text
-#endif
-END(MIPSX(VCEI))
-#endif /* MIPS3 && !MIPS3_5900 */
+END(MIPSX(tlb_enter))
 #endif /* !TSAR */
 
@@ -2070,5 +2329,5 @@
  */
 LEAF(MIPSX(lwp_trampoline))
-	PTR_ADDU sp, sp, -CALLFRAME_SIZ
+	PTR_ADDU sp, -CALLFRAME_SIZ
 
 	# Call lwp_startup(), with args from cpu_switchto()/cpu_setfunc()
@@ -2078,5 +2337,5 @@
 
 	# Call the routine specified by cpu_setfunc()
-	jal	s0			
+	jalr	s0			
 	 move	a0, s1
 
@@ -2109,11 +2368,6 @@
 	RESET_EXCEPTION_LEVEL_DISABLE_INTERRUPTS(v0)
 	COP0_SYNC
-	nop					# 3 op delay
-	nop
-	nop
 	SET_EXCEPTION_LEVEL(v0)			# set exception level
 	COP0_SYNC
-	nop
-	nop
 	REG_L	t0, CALLFRAME_SIZ+TF_REG_MULLO(sp)
 	REG_L	t1, CALLFRAME_SIZ+TF_REG_MULHI(sp)
@@ -2123,5 +2377,4 @@
 	_MTC0	v0, MIPS_COP_0_EXC_PC
 	COP0_SYNC
-	nop
 	move	k1, sp
 	REG_L	AT, CALLFRAME_SIZ+TF_REG_AST(k1)	# $1
@@ -2149,6 +2402,4 @@
 	mtc0	k0, MIPS_COP_0_STATUS
 	COP0_SYNC
-	nop
-	nop
 	eret
 	.set	at
@@ -2159,5 +2410,5 @@
  */
 LEAF(MIPSX(setfunc_trampoline))
-	PTR_ADDU sp, sp, -CALLFRAME_SIZ
+	PTR_ADDU sp, -CALLFRAME_SIZ
 
 	# Call the routine specified by cpu_setfunc()
@@ -2181,5 +2432,5 @@
 	INT_L	a1, L_MD_UPTE_0(a0)		# a1 = upte[0]
 	INT_L	a2, L_MD_UPTE_1(a0)		# a2 = upte[1]
-	PTR_L	v0, L_ADDR(a0)			# va = l->l_addr
+	PTR_L	v0, L_PCB(a0)			# va = l->l_addr
 #if VM_MIN_KERNEL_ADDRESS == MIPS_KSEG2_START
 	li	t0, VM_MIN_KERNEL_ADDRESS	# compute index
@@ -2196,4 +2447,15 @@
 #endif
 
+#if defined(MULTIPROCESSOR) && (MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+	/*
+	 * Grab the TLB lock (we could use LL/SC but this is shorter)
+	 */
+	_MFC0	a3, MIPS_COP_0_OSSCRATCH, 2
+	li	v1, __SIMPLELOCK_LOCKED
+1:	swapw	v1, a3
+	bnez	v1, 1b
+	 nop
+#endif
+
 	and	t0, v0, MIPS3_PG_ODDPG
 	beqz	t0, MIPSX(entry0)
@@ -2203,29 +2465,22 @@
 
 MIPSX(entry0):
+	_MFC0	t3, MIPS_COP_0_TLB_HI		# save TLB_HI
 	_MTC0	v0, MIPS_COP_0_TLB_HI		# VPN = va
 	COP0_SYNC
+	tlbp					# probe VPN
+	COP0_SYNC
+	mfc0	t0, MIPS_COP_0_TLB_INDEX
+#ifdef MIPS3
 	nop
-	nop
-	tlbp					# probe VPN
-	COP0_SYNC
-	nop
-	nop
-	mfc0	t0, MIPS_COP_0_TLB_INDEX
-	nop
+#endif
 	bltz	t0, MIPSX(entry0set)
 	sll	t0, t0, PGSHIFT + 1		# PAGE_SHIFT + 1
 	PTR_LA	t0, MIPS_KSEG0_START(t0)
 	_MTC0	t0, MIPS_COP_0_TLB_HI
-	COP0_SYNC
 	_MTC0	zero, MIPS_COP_0_TLB_LO0
-	COP0_SYNC
 	_MTC0	zero, MIPS_COP_0_TLB_LO1
 	COP0_SYNC
-	nop
-	nop
 	tlbwi
 	COP0_SYNC
-	nop
-	nop
 	_MTC0	v0, MIPS_COP_0_TLB_HI		# set VPN again
 	COP0_SYNC
